
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	int		num,c;
	int		buf[8];
	int		i,j;
	int		a0,sft;

	if (argc != 3) {
		fprintf(stderr, "Usage: convfont infile outfile\n");
		exit(1);
	}


/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	num = 0;
	while ((c = fgetc(infp)) != EOF) {
		if (num >= 0x7798) {
			break;
		}

		buf[num%8] = c;

		if (num < 0x80) {
			;
		} else if (0x1610 <= num && num < 0x1af0) {
			;
		} else if (num%8 == 7) {
			j = ( (num > 0x1800) ? 7 : 8);
			sft = 0x01;
			for (i = 0;i < j;i ++) {
				a0 =
					( ((buf[0] & sft) != 0) ? 0x80 : 0x00) |
					( ((buf[1] & sft) != 0) ? 0x40 : 0x00) |
					( ((buf[2] & sft) != 0) ? 0x20 : 0x00) |
					( ((buf[3] & sft) != 0) ? 0x10 : 0x00) |
					( ((buf[4] & sft) != 0) ? 0x08 : 0x00) |
					( ((buf[5] & sft) != 0) ? 0x04 : 0x00) |
					( ((buf[6] & sft) != 0) ? 0x02 : 0x00) |
					( ((buf[7] & sft) != 0) ? 0x01 : 0x00);

				fputc(a0,outfp);
				sft *= 2;
			}
		}

		num ++;
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}
